/*-
 * ========================LICENSE_START=================================
 * Copyright (C) 2021 Nordix Foundation. All rights reserved.
 * ======================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ========================LICENSE_END===================================
 */

package org.oransc.rappmanager.controller;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.gson.annotations.SerializedName;

import io.swagger.v3.oas.annotations.media.Schema;

import java.util.Collection;
import java.util.LinkedList;

import lombok.Getter;
import lombok.Setter;

import org.immutables.gson.Gson;

@Schema(name = "Chart", description = "Chart Information")
@Getter
@Setter
@JsonInclude(Include.NON_NULL)
@Gson.TypeAdapters
public class Chart {

    @Schema(name = "name", description = "name", required = true)
    @JsonProperty(value = "name", required = true)
    @SerializedName("name")
    private String name = "";

    private String version = "";
    private String description = "";
    private String apiVersion = "";
    private String appVersion = "";
    private Collection<String> urls = new LinkedList<>();
    private String digest = "";
    @JsonProperty(required = false)
    private boolean upgrade = false;
}
