/*-
 * ========================LICENSE_START=================================
 * Copyright (C) 2021 Nordix Foundation. All rights reserved.
 * ======================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ========================LICENSE_END===================================
 */

package org.oransc.rappmanager.helm;

import java.io.IOException;

import org.oransc.rappmanager.exception.ServiceException;
import org.oransc.rappmanager.service.App;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

// Supports only helm3 + version
@Component
public class HelmClient {

    @Autowired
    private HelmUtil helmUtil;

    public void addRepo(String repoName, String url) {

    }

    public void searchRepo(String chartName) {

    }

    public void repoUpdate() {

    }

    public boolean installApp(App app) throws ServiceException {
        ProcessBuilder builder = helmUtil.prepareHelmCommand(app.getName(), app.getVersion(), app.getChartName(),
            app.getReleaseNamespace(), "install");
        return executeCommand(builder);
    }

    public boolean uninstallApp(String name, String releaseNamespace) throws ServiceException {
        ProcessBuilder builder = helmUtil.prepareHelmCommand(name, null, null, releaseNamespace, "uninstall");
        return executeCommand(builder);
    }

    private boolean executeCommand(ProcessBuilder builder) throws ServiceException {
        try {
            Process process = builder.start();
            process.waitFor();
            return process.exitValue() == 0;
            // String output = IOUtils.toString(process.getInputStream(), StandardCharsets.UTF_8);
            // return output.contains("uninstalled");
        } catch (IOException | InterruptedException e) {
            throw new ServiceException("Failed to execute the Command", e);
        }
    }
}
